
R10ToStr proto :ptr real10,:PTR
include Int3264ToStr.asm
include ConvertR10.inc

R10_BIAS equ 3FFFh
R10_MANT equ 64

.xmm
.code
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

	align 16
R10ToStr proc r10:ptr REAL10, lpBuffer:PTR

	tmpbuffsize equ 32
	saveregssize equ 4*4 
	locals = tmpbuffsize + saveregssize + 4+4+4
	tmpbuff equ <[esp]>
	saveregs equ <[esp+tmpbuffsize]>
	dwSign equ <[esp+tmpbuffsize+saveregssize+0*4]>
	dwExp equ <[esp+tmpbuffsize+saveregssize+1*4]>
	dwTmp equ <[esp+tmpbuffsize+saveregssize+2*4]>
	pValue equ <[esp+locals+1*4]>
	pBuffer equ <[esp+locals+2*4]>

	sub esp,locals
	mov saveregs[0*4],ebp
	mov saveregs[1*4],esi
	mov saveregs[2*4],edi
	mov saveregs[3*4],ebx
	
	mov eax,pValue
	movsx eax,word ptr [eax+8]; SIGN+EXP
	cdq
	and eax,00000000000000000111111111111111b; clear sign, get exponent
	mov dwSign,edx
	
	mov edx,pValue
	cmp eax,111111111111111b
	mov edi,[edx+4]
	mov esi,[edx]
	je @@NaNOrInfinity

	test eax,eax
	jz @@SubnormalOrZero
	
	sub eax,R10_BIAS+63;;bin exp
	mov ecx,(1 shl 6)-1 ;; (2^n) - 1
	mov ebx,eax
	
@@SubnormalReturn:	
	; signed divide by 64 (result should be in range -78..77), remainder in ecx
	cdq 
	and edx,ecx 
	add eax,edx
	and ecx,eax
	sar eax,6
	sub ecx,edx

	mov edx,eax
	xor ebp,ebp; decexp
	sal edx,6;imul edx,eax,64
	sub ebx,edx; binexp -= ((expdiv64) * 64)
	;;;;;;;;;; expand more tble
	movsx ebp,word ptr [eax*2+R10_tab_2x10x_div_exp+256*2]
	neg ebp
	mov dwTmp,ecx; ecx=(int)(binexp%64)
	mov dwExp,ebp; decexp
	mov ebp,eax; eax=(int)(binexp/64)

	;; edi::esi *= R10_tab_2x10x_div[eax*8+256*8]
	_mul_64x64_top64 R10_tab_2x10x_div[ebp*8+256*8][0],R10_tab_2x10x_div[ebp*8+256*8][4]
	mov ebp,dwTmp
	test ebp,ebp
	.if !zero?
		movsx edx,tab_2x10x_mod_exp[ebp+64]
		add dwExp,edx
		;; edi::esi *= tab_2x10x_mod[ecx*8+64*8]
		_mul_64x64_top64 tab_2x10x_mod[ebp*8+64*8][0],tab_2x10x_mod[ebp*8+64*8][4]
	.endif
	mov ebp,dwExp; decexp

 	; 1e19 = 10000000000000000000  = 08AC72304_89E80000h
	.if edi >= 08AC72304h; Hi
		.if ( edi > 08AC72304h || esi >= 089E80000h)
			_m_div10
			add ebp,1;; increase exponent
		.endif
	.endif
	
	add esi,5
	adc edi,0
	_m_div10
	add ebp,1

	; 1e19 = 100000000000000000000  = 08AC72304_89E80000h
	.if edi >= 08AC72304h; Hi
		.if ( edi > 08AC72304h || esi >= 089E80000h)
			; round it - 20 digit -> 19
			_m_div10
			add ebp,1;; increase exponent
		.endif
	.endif
	
	mov dwExp,ebp; decexp
	lea ebx,tmpbuff
	
	invoke New_U64ToStr,edi::esi,ebx

	lea esi,[ebx-1]
	mov edi,pBuffer; 

	mov ebx,eax;18
	mov ebp,ebx
	mov byte ptr [edi],'-'; assume negative
	;trailing zero count
	.while byte ptr [esi+ebx] == '0'
		dec ebx
	.endw
	sub edi,dwSign; sign bit; byte for sign or not if +
	mov ecx,dwExp; decexp
	sub ebp,ebx
	add esi,1
	;dbg T('decexp = %i,  trailzero = %i, digs = %i',13,10,13,10),ecx,ebp,ebx
	add ecx,ebp;; trailing zero count in -> ebp
	lea edx,[ecx+ebx]
	.if zero?
		
		;; 
		;; Exponent is 0
		;;
		.repeat
			mov al,[esi]
			mov [edi],al
			add edi,1
			add esi,1
			sub ebx,1
		.until zero?
		mov byte ptr [edi],0
		
	.elseif (sdword ptr edx <= 15 && sdword ptr edx >= -3)
		;; 
		;; check for format without exp
		;;
		.if sdword ptr edx <= 0
			mov [edi],word ptr ',0'
			add edi,2
			.while sdword ptr edx < 0
				mov [edi],byte ptr '0'
				add edi,1
				add edx,1
			.endw
			.repeat
				mov al,[esi]
				mov [edi],al
				add esi,1
				add edi,1
				sub ebx,1
			.until zero?
		.elseif sdword ptr ecx <= 0
			.repeat
				mov al,[esi]
				mov [edi],al
				add esi,1
				add edi,1
				sub edx,1
				.if zero?
					mov [edi],byte ptr ','
					add edi,1
				.endif
				sub ebx,1
			.until zero?
		.else
			.repeat
				mov al,[esi]
				mov [edi],al
				add esi,1
				add edi,1
				sub edx,1
			.until zero?
		.endif
		mov byte ptr [edi],0
		
	.else
		;;
		;; Normal scientific representation
		;;
		.if byte ptr [esi] == '0'
			inc esi
			dec ebx
		.endif
		mov al,[esi]
		mov [edi],al
		add esi,1
		add edi,1
		sub ebx,1
		jz @F

		mov [edi],byte ptr ','
		add edi,1
		.repeat
			mov al,[esi]
			mov [edi],al
			add esi,1
			add edi,1
			add ecx,1
			sub ebx,1
		.until zero?
@@:
		mov eax,ecx
		sar ecx,31
		mov edx,ecx
		and ecx,'-e'-'+e'
		xor eax,edx		; abs
		add ecx,'+e'
		sub eax,edx     ;
		mov [edi],cx
		add edi,2
		invoke New_U32ToStr,eax,edi
		add edi,eax

	.endif

@@Done:
	mov eax,edi	
	mov ebp,saveregs[0*4]
	mov esi,saveregs[1*4]
	mov edi,saveregs[2*4]
	mov ebx,saveregs[3*4]
	add esp,locals
	sub eax,[esp+2*4]
	ret DWORD*2

@@NaNOrInfinity:
	mov ebx,edi
	mov eax,edi
	mov ecx,dwSign
	mov edi,pBuffer
	xor edx,edx
	mov dl,cl
	and dl,'-'
	mov [edi],dl
	sub edi,ecx
	or eax,esi
	mov dword ptr [edi],'#.1'	
	.if zero?
		mov eax,'FNI'
		mov [edi+3],eax	
		add edi,6
		jmp @@Done
	.endif
	shr ebx,30
	.if ebx == 11b
		mov eax,'NANQ'
		mov [edi+3],eax	
		mov byte ptr [edi+7],0
		add edi,7
		jmp @@Done
	.endif
	.if ebx == 10b
		mov eax,'NANS'
		mov [edi+3],eax	
		mov byte ptr [edi+7],0
		add edi,7
		jmp @@Done
	.endif
	mov eax,'DNI'
	mov [edi+3],eax	
	add edi,6
	jmp @@Done

@@Zero:
	mov ecx,dwSign
	mov edi,pBuffer
	xor edx,edx
	mov dl,cl
	and dl,'-'
	mov [edi],dl
	sub edi,ecx
	mov word ptr [edi],'0'	
	add edi,1
	jmp @@Done

@@SubnormalOrZero:
	mov edx,esi
	or edx,edi
	or edx,eax
	jz @@Zero

	mov eax,-16382-R10_MANT

	.if !edi
		mov edi,esi
		xor esi,esi
		sub eax,32
	.endif
	
	mov ecx,31
	bsr edx,edi
	sub ecx,edx
	sub eax,ecx
	shld edi,esi,cl
	shl esi,cl
	
	mov ebx,eax
	mov ecx,(1 shl 6)-1 ;; (2^n) - 1

	jmp @@SubnormalReturn
	
R10ToStr endp

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

