.code

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

;*****************************************************************
;*****************************************************************
;*****************************************************************
;*****************************************************************
;*****************************************************************
; A1::A0 = (A1::A0 * B1::B0) >> 64
_mul_64x64_top64_2 macro A0:req,A1:req, B0:req,B1:req
	mov eax,dword ptr B0
	mul A0
	mov ecx,edx; d1
	mov eax,dword ptr B1
	mul A0
	add ecx,eax;e0
	mov A0,0
	adc A0,edx;e1
	mov eax,dword ptr B0
	mul A1
	add ecx,eax;f0
	mov eax,dword ptr B1
	adc A0,edx;f1
	mov ecx,0
	mov edx,A1
	adc ecx,ecx
	mul edx
	mov A1,ecx
	add A0,eax
	adc A1,edx
endm

;*****************************************************************
;
; uint64-to-string:
;
; split the uint64 value to two 10-digit numbers by magic diver method
; if possible use uint32-to-string nested subroutine, upper 10-digits will 
; always fit to 32bit, but lower 10-digit must be adjusted dividing by 10  
; (again with magic diver method), then the remainder can be passed to 
; uint32-to-string.
;
; uint32-to-string:
;
; split the uint32 value to two 5-digit numbers by magic diver method,
; then scale the 5-digit part by 2^32/10000 (68DB9h) to get decimal
; digit in edx (upper dword) after multiplication, subsequent digits
; are got multiplying by 10
;
;*****************************************************************

align 16
New_U64ToStr proc Value:QWORD, lpszBuffer:DWORD
	push ebp
	push ebx
	push edi
	push esi
	mov edi,[esp+2*4][4*4]; a1
	mov esi,[esp+1*4][4*4]; a0
	mov ebp,[esp+3*4][4*4]; lpszBuffer
	test edi,edi
	jz @3
	_mul_64x64_top64_2 esi, edi, 0BDEDD5BFh, 0DBE6FECEh;	/10000000000
	shr edi,1
	mov esi,edi
	jnz TOP10NZ
	mov esi,[esp+1*4][4*4]; a0
	mov edi,[esp+2*4][4*4]; a1
	mov ebx,esi
@1:	add ebx,1
	adc edi,0
	_mul_64x64_top64_2 ebx, edi, 01B478423h, 0A7C5AC47h; /100000
	shrd ebx,edi,16
	imul eax,ebx,100000
	mov edx,ebx
	call DOFULL32NLZSTART
	mov eax,ebp; lpszBuffer
@2:	pop esi
	pop edi
	pop ebx
	pop ebp
	sub eax,[esp+3*4]
	ret 3*4
@3:	call DOFULL32NLZ
	mov eax,ebp; lpszBuffer
	jmp @2
	align 4
TOP10NZ:
	call DOFULL32NLZ
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; *1000000000000 == 02_540BE400h
	mov eax,0540BE400h; = b0
	mul edi
	lea edx,[2*edi+edx]; hidword is 2
	mov esi,[esp+1*4][4*4]; a0
	mov edi,[esp+2*4][4*4]; a1
	sub esi,eax
	sbb edi,edx
	mov ebx,esi; a0
	jnz @1
DOFULL32LZ:
	mov eax,0A7C5AC47h; magic div /100000
	mul esi
	add eax,0A7C5AC47h; correction for 0FFFFFFFFh
 	adc edx,0
	shr edx,16
 	mov ecx,10
	imul eax,edx,100000
	mov ebx,edx
 	sub esi,eax;/100000 remainder
	mov eax,68DB9h;2^32/10000
	mul edx
	call DIGIT0
	mov eax,ebp; lpszBuffer
	jmp @2
	;; esi == value
	;; ebp == buffer
	align 4	
DOFULL32NLZ::
	mov eax,0A7C5AC47h; magic div /100000
	mul esi
	add eax,0A7C5AC47h; correction for 0FFFFFFFFh
 	adc edx,0
	shr edx,16
	imul eax,edx,100000
	mov ebx,edx
DOFULL32NLZSTART:	
 	sub esi,eax;/100000 remainder
 	mov ecx,10
	mov eax,68DB9h;2^32/10000
	mul edx
	test ebx,ebx
	jz NEXT5
 	cmp ebx,9999
 	ja DIGIT0
 	cmp ebx,999
 	ja DIGIT1
	add eax,eax
 	cmp ebx,99
	lea eax,[eax*4+eax]
 	ja DIGIT2
	add eax,eax
 	cmp ebx,9
	lea eax,[eax*4+eax]
 	ja DIGIT3
	add eax,eax
	lea eax,[eax*4+eax]
 	jmp DIGIT4
NEXT5:
	mov eax,68DB9h;2^32/10000
	mul esi
 	cmp esi,9999
 	ja DIGIT5
 	cmp esi,999
 	ja DIGIT6
	add eax,eax
 	cmp esi,99
	lea eax,[eax*4+eax]
 	ja DIGIT7
	add eax,eax
 	cmp esi,9
	lea eax,[eax*4+eax]
 	ja DIGIT8
 	add si,'0'
	mov [ebp],si
	inc ebp
	retn
DIGIT0:
	add dl,'0'
	mov [ebp],dl
	inc ebp
DIGIT1:
	mul ecx
	add dl,'0'
	mov [ebp],dl
	inc ebp
DIGIT2:
	mul ecx
	add dl,'0'
	mov [ebp],dl
	inc ebp
DIGIT3:
	mul ecx
	add dl,'0'
	mov [ebp],dl
	inc ebp
DIGIT4:
	mul ecx
	add dl,'0'
	mov [ebp],dl
	inc ebp
	mov eax,68DB9h
	mul esi
DIGIT5:
	add dl,'0'
	mov [ebp],dl
	inc ebp
DIGIT6:
	mul ecx
	add dl,'0'
	mov [ebp],dl
	inc ebp
DIGIT7:
	mul ecx
	add dl,'0'
	mov [ebp],dl
	inc ebp
DIGIT8:
	mul ecx
	add dl,'0'
	mov [ebp],dl
	inc ebp
DIGIT9:	
	mul ecx
	add dl,'0'
	mov [ebp],dx
	inc ebp
	retn
New_U64ToStr endp
%echo New_U64ToStr: @CatStr(%($-New_U64ToStr)) bytes


New_Int64ToStr proc QwValue:QWORD,pBuffer:DWORD
	mov eax,[esp+1*4];U64.Lo
	mov edx,[esp+2*4];U64.Hi
	mov ecx,[esp+3*4];buff
	test edx,edx
	jns New_U64ToStr
	mov byte ptr [ecx],'-'
	xor eax,-1
	xor edx,-1
	inc ecx
	add eax,1
	adc edx,0	
	invoke New_U64ToStr,edx::eax,ecx
	inc eax
	ret 3*4
New_Int64ToStr endp

New_Int32ToStr proc dwValue,pBuffer
	mov eax,[esp+4];dwValue
	mov edx,[esp+8];pBuffer
	test eax,eax
	jns New_U32ToStr
	mov byte ptr [edx],'-'
	neg eax
	push ebp
	push ebx
	push esi
	mov esi,eax
	lea ebp,[edx+1]
	call DOFULL32NLZ
	mov eax,ebp;lpszBuffer
	pop esi
	pop ebx
	pop ebp
	sub eax,[esp+2*4]; strlen
	ret 2*4
New_Int32ToStr endp

New_U32ToStr proc dwValue,pBuffer
	push ebp
	push ebx
	push esi
	mov esi,[esp+1*4][3*4]; a0
	mov ebp,[esp+2*4][3*4]; lpszBuffer
	call DOFULL32NLZ
	mov eax,ebp;lpszBuffer
	pop esi
	pop ebx
	pop ebp
	sub eax,[esp+2*4]; strlen
	ret 2*4
New_U32ToStr endp

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF
